﻿using Microsoft.Win32;
using STM.EfHubService.DataAccess;
using STM.EfHubService.DataAccess.Entities;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Xml;

namespace STM.EfHubService.AdminUI
{
    public class HubStatusViewModel : ViewModelBase
    {
        public HubStatusViewModel()
        {
            LoadServices();
        }

        private ObservableCollection<Service> _services;
        public ObservableCollection<Service> Services
        {
            get
            {
                return _services;
            }
            set
            {
                if (_services == value)
                    return;

                _services = value;
                OnPropertyChanged(() => Services);
            }
        }

        private Service _selectedService;
        public Service SelectedService
        {
            get
            {
                return _selectedService;
            }
            set
            {
                if (_selectedService == value)
                    return;

                _selectedService = value;
                OnPropertyChanged(() => SelectedService);
            }
        }

        private DelegateCommand _reloadCommand;
        public DelegateCommand ReloadCommand
        {
            get
            {
                return _reloadCommand ??
                    (_reloadCommand = new DelegateCommand(ExecuteReloadCommand, CanExecuteReloadCommand));
            }
        }

        public bool CanExecuteReloadCommand(object parameter)
        {
            return true;
        }

        public async void ExecuteReloadCommand(object parameter)
        {
            LoadServices();
        }

        private void LoadServices()
        {
            using (var hubContext = new EfHubServiceDbContext())
            {
                Services = new ObservableCollection<Service>(hubContext.Service.ToList());
            }
        }

    }
}