﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Threading.Tasks;

namespace STM.EfHubService.Ais.Service
{
    static class Program
    {
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        static void Main(string[] args)
        {
            log4net.Config.XmlConfigurator.Configure();

            AppDomain.CurrentDomain.UnhandledException +=
                new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);

            if (args.Length > 0 && args[0].ToLower().Equals("-debug"))
            {
                log.Info("Starting debug mode");

                var service = new AisService();
                service.Start();

                while (true)
                { }
            }
            else if (args.Length > 0 && (args[0] == "-installservice" || args[0] == "-i"))
            {
                WindowsServiceManager SM = new WindowsServiceManager();
                if (!SM.InstallService(Environment.CurrentDirectory + "\\STM.EfHubService.Ais.Service.exe -service",
                        "EfHubAisService", "STM.EfHubService.Ais.Service"))
                    Console.Write("Service install failed.");

                return;
            }
            else if (args.Length > 0 && (args[0] == "-uninstallservice" || args[0] == "-u"))
            {
                WindowsServiceManager SM = new WindowsServiceManager();
                if (!SM.UnInstallService("EfHubAisService"))
                    Console.Write("Service failed to uninstall.");

                return;
            }

            ServiceBase[] ServicesToRun;
            ServicesToRun = new ServiceBase[]
            {
                new AisService()
            };
            ServiceBase.Run(ServicesToRun);
        }

        static void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
            log.Error(e.ExceptionObject);
        }
    }
}
