﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Azure.WebJobs;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;

namespace STM.EfHubService.Ais.WebJob
{
    class Program
    {
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        static async Task Main()
        {
            log4net.Config.XmlConfigurator.Configure();

            log.Info("Starting service");

            var builder = new HostBuilder();
            builder.ConfigureWebJobs(b =>
            {
                b.AddAzureStorageCoreServices();
            });

            builder.ConfigureLogging((context, b) =>
            {
                b.AddConsole();
            });

            var host = builder.Build();

            using (host)
            {
                await host.StartAsync();
                var jobHost = host.Services.GetService(typeof(IJobHost));
                await ((IJobHost)jobHost).CallAsync(nameof(Functions.Start));
            }
        }
    }
}
