﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;

namespace STM.EfHubService.WebApi.Controllers
{
    public class ControllerBase : ApiController
    {
        [System.Runtime.CompilerServices.MethodImpl(System.Runtime.CompilerServices.MethodImplOptions.NoInlining)]
        protected string GetCurrentMethod()
        {
            StackTrace st = new StackTrace();
            StackFrame sf = st.GetFrame(1);

            return sf.GetMethod().Name;
        }

        [System.Runtime.CompilerServices.MethodImpl(System.Runtime.CompilerServices.MethodImplOptions.NoInlining)]
        protected string GetCurrentComponent()
        {
            StackTrace st = new StackTrace();
            StackFrame sf = st.GetFrame(1);

            return sf.GetMethod().DeclaringType.FullName;
        }

        protected HttpResponseException CreateHttpResponseException(HttpStatusCode statusCode, string message)
        {
            var errorMsg = new HttpResponseMessage(statusCode)
            {
                Content = new StringContent(message),
            };
            return new HttpResponseException(errorMsg);
        }
    }
}