﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using STM.Common;
using System.Linq;
using STM.EfHubService.DataAccess.Entities;
using STM.EfHubService.DataAccess;
using System.Threading.Tasks;
using STM.EfHubService.Common.Models;
using STM.EfHubService.Common.Services;
using System.Text.RegularExpressions;
using STM.Common.XmlParsers;
using System.Text;

namespace STM.EfHubService.WebApi.Controllers
{
    public class HubStateController : ControllerBase
    {
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        public HubStateController()
        { }

        [HttpGet]
        [Route("ShipState")]
        public IEnumerable<DataAccess.Entities.Service> GetShipState()
        {
            try
            {
                using (var hubContext = new EfHubServiceDbContext())
                {
                    var services = hubContext.Service.ToList();
                    return services;
                }
            }
            catch (Exception ex)
            {
                log.Error(ex);
                var errorMsg = new HttpResponseMessage(HttpStatusCode.InternalServerError)
                {
                    Content = new StringContent(ex.Message)
                };

                throw new HttpResponseException(errorMsg);
            }
        }

        protected class ResponseObject
        {

        }
    }
}