﻿using System;
using System.Net;
using System.Web.Http;
using System.Net.Http;
using System.Web.Http.Description;
using System.Linq;

namespace STM.EfHubService.WebApi.Controllers
{
    [ApiExplorerSettings(IgnoreApi = true)]
    public class PingController : ApiController
    {
        public PingController()
        {
        }

        [HttpGet]
        [Route("ping")]
        public virtual string ping()
        {
            try
            {
                return DateTime.UtcNow.ToString("yyyy-MM-dd HH:mm:ss");
            }
            catch (Exception ex)
            {
                var errorMsg = new HttpResponseMessage(HttpStatusCode.InternalServerError)
                {
                    Content = new StringContent(ex.Message)
                };

                throw new HttpResponseException(errorMsg);
            }
        }
    }
}