﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using STM.Common;

namespace STM.EfHubService.WebApi.Helpers
{
    public class RtzHelpers
    {
        public static DateTime? GetEta(string id, Common.Models.Rtz11.Route route)
        {
            if (id == null
                || route.schedules == null
                || route.schedules.schedule == null)
                return null;

            var schedule = route.schedules.schedule.FirstOrDefault();
            if (schedule == null)
                return null;

            // Search in caculated schedule first
            if (schedule.calculated != null && schedule.calculated.scheduleElement != null)
            {
                var calculated = schedule.calculated.scheduleElement.FirstOrDefault(x => x.waypointId == id);
                if (calculated != null && calculated.etaSpecified && calculated.eta != null)
                {
                    if (calculated.eta == DateTime.MinValue)
                        return null;

                    return calculated.eta;
                }
            }

            // If not found in calculated try manual
            if (schedule.manual != null && schedule.manual.scheduleElement != null)
            {
                var manual = schedule.manual.scheduleElement.FirstOrDefault(x => x.waypointId == id);
                if (manual != null && manual.etaSpecified && manual.eta != null)
                {
                    if (manual.eta == DateTime.MinValue)
                        return null;

                    return manual.eta;
                }
            }

            return null;
        }

        public static DateTime? GetEtd(string id, Common.Models.Rtz11.Route route)
        {
            if (id == null
                || route.schedules == null
                || route.schedules.schedule == null)
                return null;

            var schedule = route.schedules.schedule.FirstOrDefault();
            if (schedule == null)
                return null;

            // Search in caculated schedule first
            if (schedule.calculated != null && schedule.calculated.scheduleElement != null)
            {
                var calculated = schedule.calculated.scheduleElement.FirstOrDefault(x => x.waypointId == id);
                if (calculated != null && calculated.etdSpecified && calculated.etd != null)
                {
                    if (calculated.etd == DateTime.MinValue)
                        return null;

                    return calculated.etd;
                }
            }

            // If not found in calculated try manual
            if (schedule.manual != null && schedule.manual.scheduleElement != null)
            {
                var manual = schedule.manual.scheduleElement.FirstOrDefault(x => x.waypointId == id);
                if (manual != null && manual.etdSpecified && manual.etd != null)
                {
                    if (manual.etd == DateTime.MinValue)
                        return null;

                    return manual.etd;
                }
            }

            return null;
        }
    }
}