﻿using STM.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Security.Cryptography.X509Certificates;
using System.Web;

namespace STM.EfHubService.WebApi.Services
{
    public class WebHelpers
    {
        public static string CheckSslCertificate(string url)
        {
            ServicePointManager.ServerCertificateValidationCallback
                = new System.Net.Security.RemoteCertificateValidationCallback(CheckServerCert);

            // Do webrequest to get info on secure site
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(WebRequestHelper.CombineUrl(url, "/voyagePlans"));

            try
            {
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                response.Close();
            }
            catch (Exception)
            { }

            // retrieve the ssl cert and assign it to an X509Certificate object

            if (request.ServicePoint.Certificate == null)
            {
                return "WARNING! The service URL is invalid or the service is not using SSL and is not SwaSWIM compliant";
            }

            X509Certificate serverCert = request.ServicePoint.Certificate;

            // convert the X509Certificate to an X509Certificate2 object by passing it into the constructor
            X509Certificate2 serverCert2 = new X509Certificate2(serverCert);

            var result = string.Format("SSL certificate issued by {0} expiration deate {1}", serverCert2.Issuer, serverCert2.GetExpirationDateString());
            if (!serverCert2.Issuer.Contains("OU=MaritimeCloud"))
            {
                result += "\r\nWARNING! the host certificate for the service is not using a certificate issued by Maritime Connectivity Platform. This indicates that the service is not SeaSWIM compliant.";
            }

            return result;
        }

        private static bool CheckServerCert(object sender, X509Certificate certification, X509Chain chain, System.Net.Security.SslPolicyErrors sslPolicyErrors)
        {
            return true;
        }
    }
}