﻿using log4net;

namespace Stm.EfHubService.WebJob2.Infrastructure
{
    public static class Log4NetExtension
    {
        static readonly log4net.Core.Level applicationLevel = new log4net.Core.Level(35000, "EF_HUB_WEBJOB");

        public static void Application(this ILog log, string message)
        {
            log.Logger.Log(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType,
                applicationLevel, message, null);
        }

        public static void ApplicationFormat(this ILog log, string message, params object[] args)
        {
            string formattedMessage = string.Format(message, args);
            log.Logger.Log(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType,
                applicationLevel, formattedMessage, null);
        }
    }

}